; Original Barrel Vise macro by Daniels @ 1280x1024 resolution - 02/01/2010

; This modified version by Cegaiel for 1024x768 resolution
;Modifed as follows:
;Set amount of barrels you want to make via dialogue
;Search for in-game popup boxes while the script runs (detect errors)
;GUI status message while the script runs

; Date: 04/17/2010

; Modifications include:
; 1) Asking how many barrels you are making instead of running continuously for 100 barrels
; 2) Constantly checking for in-game popup boxes and exiting/reloading the script when it detects one


; The following should stop runaway macros
; Ctrl+P (Pause) and Ctrl+R (Reload script)
^p::Pause
^r::Reload

; Barrel Vise - Pin window in upper left of screen.
; Coordinates are for Guilded or Public barrel vice (in other words, there should be two lines in the label):
; 1st line is "This is a Barrel Vise", 2nd line: "Usable by ???"
; If the barrel vise you are using is yours and not guilded, then you will temporarily need to change it to Public


; Pin when it is completely empty.

; Ctrl+Alt+W to start the macro
^!w::


IfWinExist eGenesis Client
{
	SetDefaultMouseSpeed, 0

;;;;;;;;;;;;;;;;;;;;;; COORD VARIABLES ;;;;;;;;;;;;;;;;;;;;;;
	
	winX := 80 			; Top of window X/Y Coords, used to select and update the pinned window
	winY := 55
	makeX := 60 		;Make button and also Take X/Y Coords
	makeY := 95
	takeAllX := makeX + 35 
	takeAllY := makeY + 10
	stokeX := 168		; Stoke Button X/Y Coords
	stokeY := 238

;160 was original and never failed value; 161-172 should work and make progress move faster, experiment with these values...
	
	barMaxFlameX := 170 ; Max Flame wanted, do not have 2 wood in Fuel passed this point.  May need to adjust.
	bar1WoodX := 71 	; Coord for determining if at least 1 wood is in Fuel
	bar2WoodX := 78 	; Coord for determining if at least 2 wood is in Fuel
	
	fuelBarY := 171  	; Y Coord for Fuel bar
	flameBarY := 187 	; Y Coord for Flame bar


	
;;;;;;;;;;;;;;;;;;;;;; MAIN PROGRAM ;;;;;;;;;;;;;;;;;;;;;;

InputBox, Qty, Barrels, How many barrels do you want to make?
counter = 0

	Gui, +AlwaysOnTop +ToolWindow
	Gui, Font, norm
	Gui, Add, Text, vMineCycleText, Preparing to start... Standby!`n`n`n`n`n
	Gui, Show
	GuiControl, Text, MineCycleText, Preparing to start... Standby!`n`n`n`n`n


	Loop, %Qty% ; number of barrels to make
	{
		WinActivate, eGenesis Client


		; Click "Make a barrel"
		MouseClickCoords(winX, winY)
		Sleep 200
		MouseClickCoords(makeX, makeY)
		Sleep 100



		;Search for a popup immediately after clicking "Make Barrel" in case we dont have the ingredients in inventory
		Gosub, SearchPopUpBox

	counter ++
GuiControl, Text, MineCycleText, Barrel: %counter% of %qty%`n`nFuel: -`nFlame: -`n`nLast: Making Barrel

		
		Loop, 10000 ; Maintain Heat
		{		

			WinActivate, eGenesis Client

;Search for popup during Maintain Heat cycle, which would mean your barrel was incinerated.
;If that happens, then try lower the coords barMaxFlameX down from 160 to maybe 155-157, No lower than 152

			Gosub, SearchPopUpBox


			curFuel1 := FindBlue(bar1WoodX, fuelBarY)
			curFuel2 := FindBlue(bar2WoodX, fuelBarY)
			curFlame := FindBlue(barMaxFlameX, flameBarY)

			if (curFuel2 = 0)
			{
			FuelStatus := 2			
			}
			else if (curFuel1 = 0)
			{
			FuelStatus := 1
			}
			else
			{
			FuelStatus := 0
			}


GuiControl, Text, MineCycleText, Barrel: %counter% of %qty%`n`nFuel: %FuelStatus% Wood`nFlame: %FlameStatus%`n`nLast: %ActionStatus%


			if (curFlame > 0)
			{					
			FlameStatus := "OK"

				if (curFuel1 > 0) ; Add 2 wood
				{
					MouseClickCoords(stokeX, stokeY)							
					MouseClickCoords(stokeX, stokeY)
					ActionStatus := "Stoke (2 Wood)"

				}
				else if (curFuel2 > 0) ; Add 1 wood
				{
					MouseClickCoords(stokeX, stokeY)
					ActionStatus := "Stoke (1 Wood)"
				}				


			} else {
			FlameStatus := "DANGER"
			ActionStatus := "No Stoke (0 Wood)"
			}



GuiControl, Text, MineCycleText, Barrel: %counter% of %qty%`n`nFuel: %FuelStatus% Wood`nFlame: %FlameStatus%`n`nLast: %ActionStatus%


			MouseClickCoords(winX, winY)
			ImageSearch, OutputX, OutputY, 12, 87, 56, 103, *50 Take.PNG
			if (ErrorLevel < 1)
			{
				break
			}
		}

		;Under rare circumstances (it clicks Stoke a micro second after the barrel completes, a popup could occur.
		;So upon detecing the "Take..." menu appear, it will first see if a popupbox exists and close it before continuing

		Gosub, ClosePopUpBox

GuiControl, Text, MineCycleText, Barrel: %counter% of %qty%`n`nFuel: -`nFlame: -`n`nLast: Unloading Barrel

		; Unload barrel
		MouseClickCoords(winX, winY)
		sleep 500
		MouseClickCoords(makeX, makeY)
		sleep 500
		MouseClickCoords(takeAllX, takeAllY)
		sleep 500
		MouseClickCoords(winX, winY)

	}

GuiControl, Text, MineCycleText, Making Barrel: %counter% of %qty%`n`nAll Done!`n`nCtrl+R to reload/reset script

}

MouseClickCoords(X, Y)
{
	MouseMove, X, Y
	sleep 100
	MouseClick
	sleep 100
}

FindBlue(TX, TY)
{	
	PixelSearch, PX, PY, TX, TY, TX+1, TY+1, 0xFD0606, 55, Fast
	return ErrorLevel
}



		SearchPopUpBox:

		WinActivate, eGenesis Client


		PixelSearch, Px, Py, 529, 481, 529, 481, 0xECDFBD, 15, Fast|RGB

		if ErrorLevel = 0
		{
		MsgBox, Popup box detected, there must be an error somewhere!`n`nReloading/Exiting script...
		RELOAD
		} else {
		return
		}



		ClosePopUpBox:

		PixelSearch, Px, Py, 529, 481, 529, 481, 0xECDFBD, 15, Fast|RGB
		if ErrorLevel = 0
		{
		Sleep 500
		Click, 529, 481
		Sleep 500
		Click, 529, 481
		Sleep 500
		}
		return